import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.datatransfer.DataFlavor;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetAdapter;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.io.File;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JSeparator;

import javazoom.jlgui.basicplayer.BasicController;
import javazoom.jlgui.basicplayer.BasicPlayer;
import javazoom.jlgui.basicplayer.BasicPlayerException;
import javazoom.spi.mpeg.sampled.file.tag.MP3Tag;

// JMF MP3 Plugin
// http://www.oracle.com/technetwork/java/javase/download-137625.html
public class BasicPlayerSample extends JFrame {

	// x[VbNvC[
	BasicPlayer player;

	// SwingpϐA萔
	// {^peLXg ~
	final static String STOP = "Stop";
	// {^peLXg Đ
	final static String PLAY = "Play";
	// {^peLXg ꎞ~
	final static String PAUSE = "Pause";
	// ^Cg
	final static String TITLE = "BasicPlayermp3Đ";
	final static String FILE_NAME = "t@CF";
	// Đ{^
	JButton bPlay;
	// Ȗx
	JLabel label;

	public static void main(String[] args) {
		new BasicPlayerSample();
	}

	// RXgN^
	public BasicPlayerSample() {
		setTitle(TITLE);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setBounds(200, 100, 300, 100);
		setLayout(new FlowLayout());

		// hbv^[Qbgݒ
		new DropTarget(this, DnDConstants.ACTION_COPY,
				new MyDropTargetListener());

		// xݒu
		label = new JLabel("@mp3t@ChbvĂB");
		label.setPreferredSize(new Dimension(getWidth() - 10, 20));
		add(label);
		add(getHr(2000, 0));

		// ĐA~{^ݒu
		bPlay = new JButton(PLAY);
		bPlay.addActionListener(new bPlayAction());
		JButton bStop = new JButton(STOP);
		bStop.addActionListener(new bStopAction());
		add(bPlay);
		add(bStop);

		// BasicPlayer̃CX^X쐬
		player = new BasicPlayer();

		setVisible(true);

		addComponentListener(new ComponentAdapter() {
			// EBhETCYω烉x̃TCYύX
			@Override
			public void componentResized(ComponentEvent e) {
				label.setPreferredSize(new Dimension(getWidth() - 10, 20));
			}
		});

	}

	// 
	public JSeparator getHr(int width, int hight) {
		JSeparator sp = new JSeparator(JSeparator.HORIZONTAL);
		sp.setPreferredSize(new Dimension(width, hight));
		return sp;
	}

	// Đ{^̃ANVNX
	class bPlayAction implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			try {
				int status = player.getStatus();
				if (status == BasicPlayer.PAUSED) {
					// ꎞ~̏ꍇAꎞ~܂
					resume();
				} else if (status == BasicPlayer.STOPPED) {
					// ~̏ꍇAĐJn܂
					play();
				} else if (status == BasicPlayer.PLAYING) {
					// Đ̏ꍇAꎞ~܂
					pause();
				}
			} catch (Exception ex) {
				// Ԃ
			}
		}
	}

	// ~{^̃ANVNX
	class bStopAction implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			try {
				stop();
			} catch (Exception ex) {
				// Ԃ
			}
		}
	}

	// ꎞ~
	private void pause() throws BasicPlayerException {
		// playMode = PLAY_MODE_PAUSE;
		player.pause();
		bPlay.setText(PLAY);
	}

	// ꎞ~
	private void resume() throws BasicPlayerException {
		player.resume();
		bPlay.setText(PLAY);
	}

	// Đ
	private void play() throws BasicPlayerException {
		player.play();
		bPlay.setText(PAUSE);
	}

	// ~
	private void stop() throws BasicPlayerException {
		player.stop();
		bPlay.setText(PLAY);
	}

	// J
	private void open(File file) throws BasicPlayerException {
		// xݒ
		label.setText(FILE_NAME + file.getName());
		// 擾t@CJ
		player.open(file);
		play(); // Đ
	}

	// hbv^[QbgXi[
	// hbvꂽt@C󂯎Aŏ̃t@CĐ܂
	class MyDropTargetListener extends DropTargetAdapter {
		@Override
		public void drop(DropTargetDropEvent dtde) {
			dtde.acceptDrop(DnDConstants.ACTION_COPY);
			boolean b = false;
			try {
				if (dtde.getTransferable().isDataFlavorSupported(
						DataFlavor.javaFileListFlavor)) {
					b = true;
					List<File> list = (List<File>) dtde.getTransferable()
							.getTransferData(DataFlavor.javaFileListFlavor);

					// ŏ̃t@C擾
					File file = list.get(0);
					open(file);
				}
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				dtde.dropComplete(b);
			}
		}
	}
}
